Subject: Re: [PATCH net 0/4] bridge: Fix problems around the PVID

From: Veaceslav Falico <[email-masked]>
Date: Fri, 13 Sep 2013 17:21:14 +0200

On Fri, Sep 13, 2013 at 09:06:53PM +0900, Toshiaki Makita wrote:
>On Thu, 2013-09-12 at 16:00 -0400, David Miller wrote:
>> From: Toshiaki Makita <[email-masked]>
>> Date: Tue, 10 Sep 2013 19:27:54 +0900
>>
>> > There seem to be some undesirable behaviors related with PVID.
>> > 1. It has no effect assigning PVID to a port. PVID cannot be applied
>> > to any frame regardless of whether we set it or not.
>> > 2. FDB entries learned via frames applied PVID are registered with
>> > VID 0 rather than VID value of PVID.
>> > 3. We can set 0 or 4095 as a PVID that are not allowed in IEEE 802.1Q.
>> > This leads interoperational problems such as sending frames with VID
>> > 4095, which is not allowed in IEEE 802.1Q, and treating frames with VID
>> > 0 as they belong to VLAN 0, which is expected to be handled as they have
>> > no VID according to IEEE 802.1Q.
>> >
>> > Note: 2nd and 3rd problems are potential and not exposed unless 1st problem
>> > is fixed, because we cannot activate PVID due to it.
>>
>> Please work out the issues in patch #2 with Vlad and resubmit this
>> series.
>>
>> Thank you.
>
>I'm hovering between whether we should fix the issue by changing vlan 0
>interface behavior in 8021q module or enabling a bridge port to sending
>priority-tagged frames, or another better way.

Take a look at how was it done for bonding - it just goes through the list
of attached vlan devs, and doesn't care about vlan0 (which can, btw, exist
technically). I'm not sure if that's what you're looking for, but worth a
try.

bond_arp_send_all() might be a good starting point.

>
>If you could comment it, I'd appreciate it :)
>
>
>BTW, I think what is discussed in patch #2 is another problem about
>handling priority-tags, and it exists without this patch set applied.
>It looks like that we should prepare another patch set than this to fix
>that problem.
>
>Should I include patches that fix the priority-tags problem in this
>patch set and resubmit them all together?
>
>
>Thanks,
>
>Toshiaki Makita
>
>>
>> --
>> To unsubscribe from this list: send the line "unsubscribe netdev" in
>> the body of a message to [email-masked]
>> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>
>
>
>--
>To unsubscribe from this list: send the line "unsubscribe netdev" in
>the body of a message to [email-masked]
>More majordomo info at  http://vger.kernel.org/majordomo-info.html